import type { InjectionKey, Ref } from 'vue';
import { createContext, useContext } from '@/hooks/application/useCtx';

type AppProviderCtxProps = {
	prefixCls: Ref<string>;
};

const key: InjectionKey<AppProviderCtxProps> = Symbol();

export function createAppProviderCtx(context: AppProviderCtxProps) {
	return createContext<AppProviderCtxProps>(key, context);
}

export function useAppProviderCtx() {
	return useContext<AppProviderCtxProps>(key);
}
