import type { PropType } from 'vue';
import { FETCH_FIELD_SETTING } from './constant';
import { PaginationProps } from './types/pagination';
import { BasicColumn, FetchFieldSetting } from './types/table';

export const basicProps = {
	columns: {
		type: Array as PropType<Array<BasicColumn>>,
		default: () => [],
	},
	actionColumn: {
		type: Object as PropType<BasicColumn>,
		default: null,
	},
	// 是否使用loading
	loading: {
		type: Boolean,
		default: true,
	},
	api: {
		type: Function as PropType<(...args: any[]) => Promise<any>>,
		default: null,
	},
	rowKey: {
		type: [String, Function] as PropType<string | ((record: Recordable) => string)>,
		default: '',
	},
	// 表头上方的标题
	title: {
		type: [String, Function] as PropType<string | ((value: Recordable) => string)>,
	},
	// 是否显示序号
	showIndexColumn: {
		type: Boolean,
		default: false,
	},
	immediate: {
		type: Boolean,
		default: true,
	},
	// 是否为树形表格
	isTreeTable: {
		type: Boolean,
		default: false,
	},
	// 表格所有单元，超过长度是否省略，columns内部优先级更高
	ellipsis: {
		type: Boolean,
		default: false,
	},
	// 分页信息
	pagination: {
		type: [Object, Boolean] as PropType<boolean | PaginationProps>,
		default: null,
	},
	fetchFieldsSetting: {
		type: Object as PropType<FetchFieldSetting>,
		default: () => FETCH_FIELD_SETTING,
	},
};
