import type { App } from 'vue';

// comp list
import { AppProvider } from '@/components/application';
import { BasicTitle, BasicHelp } from '@/components/basic';
import { Icon, IconFont } from '@/components/icon';
import { BasicTable, useTable } from '@/components/table';

const compList = [AppProvider, BasicTitle, BasicHelp, BasicTable];

const install = (app: App) => {
	compList.map(comp => {
		app.component(comp.name || comp.displayName, comp);
	});
}

// 未使用模块化引入，通过script标签引入
if (window?.vue) {
	install(window.vue);
}

export default {
	install,
	...compList,
	Icon,
	IconFont,
	useTable,
};
