import type { App, Plugin } from 'vue';

export function withInstall<T>(component: T, alias?: string) {
	const comp = component as any;
	comp.install = (app: App) => {
		app.component(comp.name || comp.displayName, comp);
		if (alias) {
			app.config.globalProperties[alias] = component;
		}
	};
	return component as T & Plugin;
}
