const useToString = Object.prototype.toString;

export function is(val: unknown, type: string) {
	return useToString.call(val) === `[object ${type}]`;
}

export function isString(val: unknown): val is string {
	return is(val, 'String');
}

export function isBoolean(val: unknown): val is boolean {
	return is(val, 'Boolean');
}

export function isFunction(val: unknown): val is (...args: any[]) => any {
	return typeof val === 'function';
}

export function isArray(val: unknown) {
	return Array.isArray(val);
}
